
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was PDALConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

set(PDAL_VERSION_MAJOR 1)
set(PDAL_VERSION_MINOR 8)
set(PDAL_VERSION_PATCH 0)

set(PDAL_INCLUDE_DIRS)
set(PDAL_LIBRARY_DIRS)
foreach(_dir @@HOMEBREW_CELLAR@@/osgeo-pdal/1.8.0/include)
  set_and_check(_foo ${_dir})
  list(APPEND PDAL_INCLUDE_DIRS ${_foo})
endforeach(_dir)
foreach(_dir @@HOMEBREW_CELLAR@@/osgeo-pdal/1.8.0/lib)
  set_and_check(_foo ${_dir})
  list(APPEND PDAL_LIBRARY_DIRS ${_foo})
endforeach(_dir)

include("${CMAKE_CURRENT_LIST_DIR}/PDALTargets.cmake")

if (WIN32)
# On windows link in pdal_util as well
  set(PDAL_LIBRARIES "pdalcpp" "pdal_util")
else (WIN32)
  set(PDAL_LIBRARIES "pdalcpp")
endif(WIN32)

check_required_components(PDAL)
